# a mail sendy thing using smtp
import gtk
import timeoutsocket
import smtplib
import string
from ptk.big_edit_box import *
import pynei18n
from boxtypes.net_exceptions import *

AUTH_NO = 0
AUTH_YES = 1

class smtp_send:
	def __init__(self, conf):
		self.conf = conf
	
	def get_connection(self):
		try:
			self.connection = smtplib.SMTP(self.conf["server"], self.conf["port"])
			
			if self.conf["auth"] == AUTH_YES:
				try:
					self.connection.login(self.conf["username"], self.conf["password"])
				except smtplib.SMTPException, e:
					raise auth_exception(e)
		except smtplib.SMTPException, e:
			raise connect_exception(e)

	def post_message(self, msg):
		"""
		Post message 'msg'.
		"""
		# make list of target addresses
		adds = string.split(msg.headers["to"], ",")
		if msg.headers.has_key("cc"):
			adds = adds + string.split(msg.headers["cc"], ",")
		if msg.headers.has_key("bcc"):
			adds = adds + string.split(msg.headers["bcc"], ",")
		# clean up
		for i in range(0, len(adds)):
			adds[i] = string.strip(adds[i])
		try:
			self.connection.sendmail(msg.headers["from"], adds, msg.body)
		except smtplib.SMTPException, e:
			raise send_exception(e)
	
	def close(self):
		self.connection.quit()

def fix_defaults(conf):
	conf["port"] = 25
	conf["auth"] = AUTH_NO

def get_connection(conf):
	"""
	return a connection object thingy.
	"""
	c = smtp_send(conf)
	c.get_connection()
	return c

def setup(parent_mailbox, conf, parent_win):
	"""
	Open a configuration dialog box.
	"""
	win = gtk.Window()
	win.set_title(_("%s SMTP Settings") % parent_mailbox.name)
	win.set_transient_for(parent_win)

	box = gtk.VBox()
	box.set_border_width(5)
	win.add(box)
	box.show()

	# dummy class object for settings
	class _dummy:
		pass
	settings = _dummy()
	settings.__dict__ = conf

	settings_box0 = big_edit_box( settings,
	      ( ("server", _("SMTP server:"), VAR_TYPE_STRING, 0, 0),
		("port", _("Port:"), VAR_TYPE_INTEGER, 0, 25) )
	)
	box.pack_start(settings_box0, expand=False)
	settings_box0.show()

	
	auth_state = [ conf["auth"] ]

	# authentication?
	toggle_auth = gtk.CheckButton(_("Authenticate"))
	if conf["auth"] == AUTH_NO:
		toggle_auth.set_active(False)
	else:
		toggle_auth.set_active(True)
	box.pack_start(toggle_auth, expand=False)
	toggle_auth.show()

	
	settings_box1 = big_edit_box( settings,
	      ( ("username", "Username:", VAR_TYPE_STRING, 0, 0),
		("password", "Password:", VAR_TYPE_STRING, MOD_HIDE, 0) )
	)
	box.pack_start(settings_box1, expand=False)
	settings_box1.show()
	
	def _update_auth(settings_box1=settings_box1, auth_state=auth_state):
		if auth_state[0] == AUTH_NO:
			settings_box1.set_sensitive(False)
		else:
			settings_box1.set_sensitive(True)

	def _toggle_auth(w, auth_state=auth_state, _update_auth=_update_auth):
		if auth_state[0] == AUTH_NO:
			auth_state[0] = AUTH_YES
			_update_auth()
		else:
			auth_state[0] = AUTH_NO
			_update_auth()

	_update_auth()
	
	toggle_auth.connect("toggled", _toggle_auth)
	
	# separator between entry boxes and buttons
	separator = gtk.HSeparator()
	box.pack_start(separator, expand=False)
	separator.show()

	def save_changes(_button, win=win, settings=settings, settings_box0=settings_box0, \
			settings_box1=settings_box1, auth_state=auth_state, conf=conf):
		# Extract info
		settings_box0.apply_changes()
		settings_box1.apply_changes()
		conf["auth"] = auth_state[0]
		win.destroy()

	def _cancel(_button, win=win):
		win.destroy()

	# boootons
	buttonbox = gtk.HBox(spacing=5)
	buttonbox.set_border_width(5)
	box.pack_start(buttonbox, expand=False)
	buttonbox.show()

	button = gtk.Button(stock="gtk-cancel")
	button.connect("clicked", _cancel)
	buttonbox.pack_end(button, expand=False)
	button.show()

	button = gtk.Button(stock="gtk-ok")
	button.connect("clicked", save_changes)
	buttonbox.pack_end(button, expand=False)
	button.show()

	win.show()

	
